// This files provides a common interfice for lightcurve input and output to be used by
// all the VaST routines. The goal is to be able to easily track the exact format in 
// which the lightcurves are stored.

#include <stdio.h>

__inline int write_lightcurve_point( FILE * lc_file_descriptor, double jd, double mag, double mag_err, double x, double y, double app, char * string){
 fprintf( lc_file_descriptor, "%.5lf %8.4lf %.4lf  %10.5lf %10.5lf %4.1lf %s\n", jd, mag, mag_err, x, y, app, string);
 return 0;
}

__inline int read_lightcurve_point( FILE * lc_file_descriptor, double * jd, double * mag, double * mag_err, double * x, double * y, double * app, char * string){
 char * str;

// fprintf(stderr,"Ohahaha\n");

 str=malloc(DATA_PARSER_C_MAX_STR_LENGTH*sizeof(char));
 if( NULL==fgets( str, DATA_PARSER_C_MAX_STR_LENGTH, lc_file_descriptor) ){free(str);return 1;}
 str[DATA_PARSER_C_MAX_STR_LENGTH-1]='\0'; // just in case
 if( 7!=sscanf( str, "%lf %lf %lf  %lf %lf %lf %s\n", jd, mag, mag_err, x, y, app, string) ){
  string[0]='\0';
  (*app)=1.0;
  (*x)=(*y)=0.0;
  if( 3!=sscanf( str, "%lf %lf %lf\n", jd, mag, mag_err) ){
   (*mag_err)=0.02;
   if( 2!=sscanf( str, "%lf %lf\n", jd, mag) ){
    return 1;
   }
  }
 }
 free(str);
 
// fprintf(stderr,"Ahahaha\n");
 
 return 0;
}
